// This may look like C code, but it is really -*- C++ -*-
/*
 *************************************************************************
 *
 *			Basic Dialog class for XVT
 *
 * Handle some common chores for a modal dialog: do some trivial event
 * processing, handle clicking on the Cancel button, enabling/disabling
 * dialog items etc.
 * For non-trivial things we call some virtual functions that should be defined
 * in the derived classes.
 * Note, after the dialog has been created, the entire show is over, and
 * the dialog object keeps the result of the selection.
 *
 * $Id: Dialog.cc,v 2.0 1994/07/06 18:55:41 oleg Exp oleg $
 *
 *************************************************************************
 */

#ifndef __GNUC__
#pragma implementation
#endif
#include "Dialog.h"


					// Initialize the dialog data
XVTModalDialog::XVTModalDialog(const short resource_id)
{
  dialog_id = resource_id;
}

			// This function actually creates the dialog and runs
  			// the show
			// Note, create_res_dialog() function returns when
			// the dialog has run and finished, or when failed
			// to create the dialog
void XVTModalDialog::commence(void)
{
  				// Note, if everything was OK, the dialog
				// already has been destroyed when the
				// function returns
  assert( create_res_dialog(WD_MODAL,dialog_id,EM_ALL,
			    (EVENT_HANDLER)q_universal_handler(),
			    (long)this) != 0 );
}

			// Just initialize the dialog data
			// No window is created yet (that's why this
			// constructor is protected - to avoid confusion)
XVTDialog::XVTDialog(const short resource_id)
{
  dialog_id = resource_id;
}

			// This function actually creates the dialog, and that
  			// is it. It brings up a window which is handled the
			// same way as other regular windows/modeless dialogs.
			// Don't forget to call serve_to_death() later on
			// to handle events (for all active windows).
void XVTDialog::commence(void)
{
  assert( create_res_dialog(WD_MODELESS,dialog_id,EM_ALL,
			    (EVENT_HANDLER)q_universal_handler(),
			    (long)this) != 0 );
}
