// This may look like C code, but it is really -*- C++ -*-
/*
 *************************************************************************
 *
 *			A simple XVT Task Manager
 *
 * This program contains the main() function that just initializes the
 * XVT and does a _very_ basic task event handling
 *
 * $Id: SimpleProcess.cc,v 1.1 1994/06/28 21:34:24 oleg Exp oleg $
 *
 *************************************************************************
 */

#ifdef __GNUC__
#pragma implementation
#endif
#include "SimpleProcess.h"

				// A Very basic event handler - handles only
				// CREATE (task manager window), DESTROY
				// and QUIT events. Usually Task manager
				// won't get anything else anyway.
#ifdef __SC__
			// Variable number of arguments is just to
			// force the C calling convention. Normally
			// member functions are called using the
			// pascal conventions in Symantec C++
long SimpleProcess::task_handler(WINDOW win, EVENT *ep,...)
#else
long SimpleProcess::task_handler(WINDOW win, EVENT *ep)
#endif
{
  switch( ep->type )
  {
    case E_CREATE:
         start();		// Here is where we run our process
         break;
			
    case E_DESTROY:		// XVT system thus notifies us it's coming
	 break;			// down and we may want to dealloc smth
			
    case E_QUIT:		// Usually happens only on Mac when got a
	 xvt_terminate();	// QUIT event from Finder

    default:
	 break;
  }
  return 0;
}

				// Real "root" module
main(const short argc, char * argv[])
{
#if (XVT_OS==XVT_OS_MAC)
			// Open stdout and stderr - to create a UNIX env on Mac
  const char * stdout_file_name = "stdout";
  const char * stderr_file_name = "stderr";
	
  assert( freopen(stdout_file_name,"w",stdout) != NULL );
  assert( freopen(stderr_file_name,"w",stderr) != NULL );

			// Create the file buffer and attach it to the
			// same stream as stdout
  filebuf * fbp = new filebuf;
  assert( (*fbp).attach(fileno(stdout),ios::out) != 0 );
  cout = fbp; 		// Attach cout and cerr to the same file as
  cerr = fbp;		// stdout
  cout.setf(ios::unitbuf);	// Make sure buffers are flushed after each i/o
  cerr.setf(ios::unitbuf);
	
  assert( cout.good() && cerr.good() );
#endif

  SimpleProcess process;

  xvt_system(argc, argv, 0, SimpleProcess::task_handler, 
	     (XVT_CONFIG*)process.q_config() );
}

