// This may look like C code, but it is really -*- C++ -*-
/*
 *************************************************************************
 *
 *		     Interface to a simple XVT Task Manager
 *
 * defines a basic class SimpleProcess that provides basic handling of task
 * events. Other programs are welcome to change things as they see fit:
 * derive from the class, add specific program data and override default
 * event handling. Every class should provide implementation for q_config()
 * function
 *
 * $Id: SimpleProcess.h,v 1.1 1994/06/26 17:21:26 oleg Exp oleg $
 *
 *************************************************************************
 */

#ifndef __GNUC__
#pragma once
#else
#pragma interface
#endif

#include <xvt.h>

class SimpleProcess
{
  XVT_CONFIG config;
  
  static void start(void);	// The function that is called on start-up
  
protected:

public:
  SimpleProcess(void);
  ~SimpleProcess(void) {}
	
  const XVT_CONFIG * q_config(void) const	{ return &config; }

#ifdef __SC__
			// Variable number of arguments is just to
			// force the C calling convention. Normally
			// member functions are called using the
			// pascal conventions in Symantec C++
  static long task_handler(WINDOW win, EVENT *ep,...);
#else
  static long task_handler(WINDOW win, EVENT *ep);
#endif
};
