// This may look like C code, but it is really -*- C++ -*-
/*
 *************************************************************************
 *
 *			   XVT Service classes
 *		implementation of some non-inline functions
 *
 * $Id: xvt-serv.cc,v 1.2 1994/06/26 17:21:24 oleg Exp oleg $
 *
 *************************************************************************
 */

#ifndef __GNUC__
#pragma implementation
#endif

#include "xvt-serv.h"

/*
 *------------------------------------------------------------------------
 *			Operations on lists
 */
				// Replace the data in the current element
				// Replacement is done by removing the old
				// element and creating a new one with new
				// contents
				// We try to preserve the order (approximately)
				// The new element is inserted almost at the
				// same position
void ListofStrings::curr_replace(const char * str, const long key)
{
  assert( slist_valid(list) );
  assert(curr_elem != 0);
  SLIST_ELT next_elt = slist_next(list,curr_elem);
  assert( slist_rem(list,curr_elem) );
  assert( slist_add(list,next_elt,(char *)str,key) );
}

				// Set a current elmt by its index (origin 0)
				// No fancy search is here - just dumb
				// enumeration
void ListofStrings::set_curr_by_index(const short index)
{
  assert( slist_valid(list) );
  register int i;
  for(i=0, curr_elem = slist_first(list); i<index; 
      curr_elem=slist_next(list,curr_elem),i++)
    if( curr_elem == NULL )
      xvt_fatal("Can't find %ld-th element in the list",index);
}
